<%- include('../partials/header') %>
<%- include('../partials/scripts') %>
</head>

<body class="min-vh-100 d-flex flex-column">
	<%- include('../partials/navbar') %>
	<div class="main-content d-flex flex-column flex-grow-1">
		<%- include('../partials/topbar') %>
		<%- include('./header', { active: 'edit' }) %>
		<!-- Page content -->
		<div class="container-fluid mt--7 flex-grow-1">
			<div class="row">
				<div class="col-xl-4 order-xl-2">
					<div class="card card-profile">
						<img src="../../assets/img/theme/img-1-1000x600.jpg" alt="Default image background"
							class="card-img-top">
						<div class="row justify-content-center">
							<div class="col-lg-3 order-lg-2">
								<div class="card-profile-image">
									<a href="#">
										<img src="<%= user.photo %>" class="rounded-circle">
									</a>
								</div>
							</div>
						</div>
						<div class="card-header text-center border-0 pt-8 pt-md-4 pb-0 pb-md-4">
							<div class="d-flex justify-content-between">
								<a href="mailto:<%= user.email %> "
									class="btn btn-sm btn-default float-right ml-auto">Poslat email</a>
							</div>
						</div>
						<div class="card-body">
							<div class="text-center">
								<h5 class="h3">
									<%= user.name.first %> <%= user.name.middle %>
									<%= user.name.last %>
								</h5>
								<div class="h5 font-weight-300">
									<%= user.email %>
								</div>
								<div class="mt-3">
									<% if (user.type === 'admin') { %>
									<i class="fas fa-user-cog"></i>
									Administrátor (ka)
									<% } else if (user.type === 'guarantor') { %>
									<i class="fas fa-user-tie"></i>
									Garant (ka)
									<% } else if (user.type === 'student') { %>
									<i class="fas fa-user-graduate"></i>
									Student (ka)
									<% } %>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="col-xl-8 order-xl-1">
					<div class="card">
						<div class="card-header">
							<div class="row align-items-center">
								<div class="col-12">
									<h3 class="mb-0">Editace uživatele</h3>
								</div>
							</div>
						</div>
						<div class="card-body bg-secondary">
							<form action="./" id="edit-user-form" method="POST">
								<h6 class="heading-small text-muted mb-4">Základní údaje</h6>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="firstname">Křestní
													jméno</label>
												<input type="text" id="firstname" class="form-control" required
													placeholder="Vyplňte prosím toto povinné pole"
													value="<%= user.name.first %>">
											</div>
										</div>
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="middlename">Prostřední
													jméno</label>
												<input type="text" id="middlename" class="form-control"
													placeholder="Žádné" value="<%= user.name.middle %>">
											</div>
										</div>
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="lastname">Příjmení</label>
												<input type="text" id="lastname" class="form-control" required
													placeholder="Vyplňte prosím toto povinné pole"
													value="<%= user.name.last %>">
											</div>
										</div>
									</div>
									<div class="row">
										<div class="col-md-6 col-sm-12">
											<div class="form-group">
												<label class="form-control-label" for="email">Email</label>
												<input type="email" id="email" class="form-control" required
													placeholder="Vyplňte prosím toto prázdné povinné pole"
													value="<%= user.email %>">
											</div>
										</div>
										<div class="col-md-6 col-sm-12">
											<div class="form-group">
												<label class="form-control-label" for="user-type">Role</label>
												<select class="form-control" id="user-type">
													<option <%= user.type === 'student' ? 'selected="selected"' : '' %>
														value="student">Student(ka)</option>
													<option <%= user.type === 'guarant' ? 'selected="selected"' : '' %>
														value="guarant">Garant(ka)</option>
													<option <%= user.type === 'admin' ? 'selected="selected"' : '' %>
														value="admin">Administrátor(ka)</option>
												</select>
											</div>
										</div>
									</div>
								</div>
								<div class="row">
									<div class="col float-left">
										<h6 class="heading-small text-muted mb-4">Ročníky</h6>
									</div>
									<div class="col float-right">
										<button type="button" onclick="addYearRow()"
											class="btn btn-sm btn-primary float-right">Přidat ročník</button>
									</div>
								</div>
								<div class="pl-lg-4">
									<div id="user-years">
										<% user.years.forEach((yearObject, i) => { %>
										<div class="row">
											<div class="col-md-6 col-sm-12">
												<div class="form-group">
													<label class="form-control-label" for="user-year-<%= i %>">
														Ročník
													</label>
													<select class="form-control" id="user-year-<%= i %>"
														required="required">
														<option value="">
															Vyberte ročník
														</option>
														<% years.forEach((yearFromDB) => { %>
														<option
															<%= String(yearObject.year._id) == String(yearFromDB._id) ? 'selected="selected"' : '' %>
															value="<%= yearFromDB._id %>">
															<%= yearFromDB.name %>
														</option>
														<% }) %>
													</select>
												</div>
											</div>
											<div class="col-md-5 col-sm-12">
												<div class="form-group">
													<label class="form-control-label"
														for="user-year-permissions-<%= i %>">
														Práva
													</label>
													<select class="form-control" id="user-year-permissions-<%= i %>"
														required="required">
														<option selected="selected" value="" disabled="disabled">
															Vyberte práva k ročníku
														</option>
														<option
															<%= yearObject.permissions.includes('read') ? 'selected="selected"' : '' %>
															value="read">Čtení</option>
														<option
															<%= yearObject.permissions.includes('edit') ? 'selected="selected"' : '' %>
															value="edit">Editace</option>
													</select>
												</div>
											</div>
											<div class="col-1 m-auto">
												<button class="btn btn-danger m-auto" type="button"
													onclick="$(this).parent().parent().remove()">×</button></div>
										</div>
										<% }) %>
									</div>
									<div class="row">
										<div class="col" id="edit-user-status" style="display: none;"></div>
										<div class="col-4 text-left">
											<button type="button" class="btn btn-primary"
												id="edit-user-button">Editovat</button>
										</div>
									</div>
								</div>
							</form>
							<hr class="my-4">
							<h6 class="heading-small text-muted mb-4">Změna hesla</h6>
							<div class="pl-lg-4">
								<form action="./" method="POST" id="change-password-form">
									<div class="row">
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="new-password">Nové
													heslo</label>
												<input type="password" id="new-password" class="form-control" required
													placeholder="Vyplňte prosím toto povinné pole">
											</div>
										</div>
									</div>
									<div class="row">
										<div class="col" id="change-password-status" style="display: none;">
										</div>
										<div class="col-4 text-left">
											<button type="submit" class="btn btn-primary"
												id="change-password-button">Editovat</button>
										</div>
									</div>
								</form>
							</div>
						</div>
					</div>
				</div>
			</div>
			<%- include('../partials/footer') %>
		</div>
	</div>
	<%- include('../partials/scripts-file-end') %>
	<%- include('../partials/select2') %>
	<script>
		function addYearRow(i = $('div#user-years .row').length, motherDOM = $('div#user-years')) {
			$('<div>', { class: 'row' }).append(
				$('<div>', { class: 'col-md-6 col-sm-12' }).append(
					$('<div>', { class: 'form-group' }).append(
						$('<label>', { class: 'form-control-label', for: `user-year-${i}` }).text('Ročník'),
						$('<select>', { class: 'form-control', id: `user-year-${i}`, required: 'required' })
					)
				),
				$('<div>', { class: 'col-md-5 col-sm-12' }).append(
					$('<div>', { class: 'form-group' }).append(
						$('<label>', { class: 'form-control-label', for: `user-year-permissions-${i}` }).text('Práva'),
						$('<select>', { class: 'form-control', id: `user-year-permissions-${i}`, required: 'required' }).append(
							$('<option>', { value: 'read' }).text('Čtení'),
							$('<option>', { value: 'edit' }).text('Editace'),
						)
					)
				),
				$('<div>', { class: 'col-1 m-auto' }).append(
					$('<button>', { class: 'btn btn-danger m-auto', type: 'button', onclick: '$(this).parent().parent().remove()' }).html('&times;')
				)
			).appendTo(motherDOM)
			$(`select#user-year-permissions-${i}`).select2()
			let $selectUsersYear = $(`select#user-year-${i}`).select2()
			$selectUsersYear.html(`<option selected="selected" value>Načítání...</option>`)
			$selectUsersYear.prop("disabled", true);
			API.year.list().done((listOfYears) => {
				$selectUsersYear.html(`<option selected="selected" value disabled="disabled">Vyberte ročník</option>`)
				listOfYears.forEach((year) => {
					$selectUsersYear.append(`<option value="${year._id}">${year.name}</option>`)
				})
				$selectUsersYear.prop("disabled", false);
			})
		}

		function getYearsForRequest() {
			let years = []

			for (let i = 0; i < $('div#user-years .row').length; i++) {
				let year = {
					permissions: ['read'],
					year: $(`select#user-year-${i}`).val()
				}
				
				if ($(`select#user-year-permissions-${i}`).val() === 'edit') {
					year.permissions.push('edit')
				}
				years.push(year)
			}

			return years
		}
		function editProfile() {
			API.user
				.edit({
					id: '<%= user._id %>',
					firstname: $('#firstname').val(),
					middlename: $('#middlename').val(),
					lastname: $('#lastname').val(),
					email: $('#email').val(),
					years: getYearsForRequest()
				})
				.done(function (data) {
					console.log(data)
					let $status = $('div#edit-user-status')
					if (data === 'ok') {
						$status
							.empty()
							.append(
								$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
									$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
									$('<strong>').text('Gratuluji!'),
									' Úspěšně jste si upravil(a) uživatele'
								)
							)
							.show()
						// Refresh the page
						setTimeout(function () {
							window.location.href = window.location.href;
						}, 3500)
					} else {
						$status
							.empty()
							.append(
								$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
									$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
									$('<strong>').text('Ach ne! '),
									data
								)
							)
							.show()
					}
				})
		}

		function changePassword() {
			API.user
				.setNewPassword('<%= user._id %>', $('#new-password').val())
				.done(function (data) {
					console.log(data)
					if (data === 'ok') {
						$('div#change-password-status')
							.empty()
							.append(
								$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
									$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
									$('<strong>').text('Gratuluji!'),
									' Úspěšně jste změnil(a) heslo uživateli'
								)
							)
							.show()
						// Refresh the page
						setTimeout(function () {
							window.location.href = window.location.href;
						}, 3500)
					} else {
						$('div#change-password-status')
							.empty()
							.append(
								$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
									$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
									$('<strong>').text('Ach ne! '),
									data
								)
							)
							.show()
					}
				})
		}

		$(document).ready(function () {
			$('select').select2()
			$('#edit-user-button').click(editProfile)
			$('#edit-user-form').submit(function (event) {
				event.preventDefault()
				editProfile()
			})

			$('#change-password-button').click(changePassword)
			$('#change-password-form').submit(function (event) {
				event.preventDefault()
				changePassword()
			})
		})
	</script>
	<%- include('../partials/file-end') %>
